﻿# -*- coding: utf-8 -*-
"""
Created on Tue Sep 30 20:42:42 2014

@author: Manuel Martin
	    Curso de Graficación FCC BUAP 2014
"""

import sys, math
from numpy import random
from PyQt4 import QtGui, QtCore

def signo(x):
    if x < 0:
        return -1
    elif x > 0:
        return 1
    else:
        return 0
        
        

class Fractales(QtGui.QWidget):
    
    def __init__(self):
        super(Fractales, self).__init__()
        
        self.initUI()
        
    def initUI(self):             
        
        self.titulo = QtGui.QLabel('F R A C T A L E S', self)
        self.titulo.move(30,12)
        
        self.labelN = QtGui.QLabel('N (1000,50000) = ', self)
        self.labelN.move(40,36)

        self.le = QtGui.QLineEdit(self)
        self.le.setText('5000')
        self.le.move(130, 32)
        
        self.boton = QtGui.QPushButton('Actualiza', self)
        self.boton.move(270,30)
        self.boton.clicked.connect(self.boton1Click)        
                
        self.setGeometry(100, 50, 400, 440)
        self.setMaximumHeight(440)
        self.setMinimumHeight(440)
        self.setMaximumWidth(400)
        self.setMinimumWidth(400)
        
        # inicializamos la variable Np
        self.Np = 5000
        
        self.setWindowTitle('El Atractor de Barry Martin - 2014')
        self.show()
        
            
    # evento del boton
    def boton1Click(self):
        N = int(self.le.text())
        if N<1000:
            N = 1000
        elif N>50000:
            N = 50000
            
        ss = QtCore.QString(str(N))    
        self.le.setText(ss)    
        
        self.Np = N        
        self.repaint()
            
    # repinta la interface cuando es necesario            
    def paintEvent(self, e):
        qp = QtGui.QPainter()
        qp.begin(self)
        self.fractal(qp)
        qp.end()

    def fractal(self,qp):
        # linea divisoria
        x1 = 20
        y1 = 60
        x2 = 380
        y2 = 60
        qp.drawLine(x1,y1,x2,y2)
        
        # rectangulo gris   
        colorP = QtGui.QColor(40, 40, 200)
        qp.setPen(colorP)
        colorB = QtGui.QColor(0, 0, 0)
        qp.setBrush(colorB)
        
        ww = 360
        qp.drawRect(20, 65, ww, ww)
        
        # El fractal
        A = -11.0
        B =   0.3        
        C =  -0.5
                
        x0 = 200
        y0 = 245

        # cálculo de cotas        
        x = 0
        y = 0
        
        xmin, xmax  = 10000, -10000
        ymin, ymax  = 10000, -10000
        Rmax = -1
                
        for i in range(self.Np):
            xp = y - signo(x)*math.sqrt(abs(B*x - C))
            yp = A - x

            R = math.sqrt(x*x + y*y)
            Rmax = max(Rmax,R)
            
            xmin,ymin  = min(xmin,xp), min(ymin,yp)            
            xmax,ymax  = max(xmax,xp), max(ymax,yp)            
            
            x,y = xp, yp
            
        # factores de escala    
        dx = abs(xmax - xmin)
        dy = abs(ymax - ymin)
        
        fx = 0.7*ww/dx
        fy = 0.7*ww/dy
        
        pm = ww/(4*min(dx,dy))
        
        # primer color
        colorT = QtGui.QColor(250, 250, 250)        
        qp.setPen(colorT)        
        
        # pintando y centrando
        random.seed(2014)        
        for i in range(self.Np):
            xx = fx*(x + pm) + x0 
            yy = fy*(y + pm) + y0

            # El color se va cambiando cada Nc puntos

            if (i % 1000) == 0:
                cr = int( random.randint(100,255) )
                cg = int( random.randint(120,255) )
                cb = int( random.randint(140,255) )
                colorT = QtGui.QColor(cr, cg, cb)        
                qp.setPen(colorT)

            qp.drawPoint(xx, yy)
            
            xp = y - signo(x)*math.sqrt(abs(B*x - C))
            yp = A - x
            
            x,y = xp, yp

        
def main():
    
    app = QtGui.QApplication(sys.argv)
    ex = Fractales()
    sys.exit(app.exec_())


if __name__ == '__main__':
    main()

